ptx: fix an invalid heap reference with short --width
[coreutils.git] / tests / misc / timeout.sh
blob208c954c5e5a733cdc35cc00c86b0acac1fcb5cc
1 #!/bin/sh
2 # Validate timeout basic operation
4 # Copyright (C) 2008-2016 Free Software Foundation, Inc.
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 3 of the License, or
9 # (at your option) any later version.
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
16 # You should have received a copy of the GNU General Public License
17 # along with this program. If not, see <http://www.gnu.org/licenses/>.
19 . "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
20 print_ver_ timeout
21 require_trap_signame_
23 # no timeout
24 timeout 10 true || fail=1
26 # no timeout (suffix check)
27 timeout 1d true || fail=1
29 # disabled timeout
30 timeout 0 true || fail=1
32 # exit status propagation
33 returns_ 2 timeout 10 sh -c 'exit 2' || fail=1
35 # timeout
36 returns_ 124 timeout .1 sleep 10 || fail=1
38 # exit status propagation even on timeout
39 # exit status should be 128+TERM
40 returns_ 124 timeout --preserve-status .1 sleep 10 && fail=1
42 # kill delay. Note once the initial timeout triggers,
43 # the exit status will be 124 even if the command
44 # exits on its own accord.
45 returns_ 124 timeout -s0 -k1 .1 sleep 10 && fail=1
47 # Ensure 'timeout' is immune to parent's SIGCHLD handler
48 # Use a subshell and an exec to work around a bug in FreeBSD 5.0 /bin/sh.
50 trap '' CHLD
52 exec timeout 10 true
53 ) || fail=1
55 # Don't be confused when starting off with a child (Bug#9098).
56 out=$(sleep .1 & exec timeout .5 sh -c 'sleep 2; echo foo')
57 status=$?
58 test "$out" = "" && test $status = 124 || fail=1
60 Exit $fail